//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class CustomBondForce : Force {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal CustomBondForce(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.CustomBondForce_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(CustomBondForce obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~CustomBondForce() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_CustomBondForce(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public CustomBondForce(string energy) : this(OpenMMSwigPINVOKE.new_CustomBondForce(energy), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int getNumBonds() {
    int ret = OpenMMSwigPINVOKE.CustomBondForce_getNumBonds(swigCPtr);
    return ret;
  }

  public int getNumPerBondParameters() {
    int ret = OpenMMSwigPINVOKE.CustomBondForce_getNumPerBondParameters(swigCPtr);
    return ret;
  }

  public int getNumGlobalParameters() {
    int ret = OpenMMSwigPINVOKE.CustomBondForce_getNumGlobalParameters(swigCPtr);
    return ret;
  }

  public int getNumEnergyParameterDerivatives() {
    int ret = OpenMMSwigPINVOKE.CustomBondForce_getNumEnergyParameterDerivatives(swigCPtr);
    return ret;
  }

  public string getEnergyFunction() {
    string ret = OpenMMSwigPINVOKE.CustomBondForce_getEnergyFunction(swigCPtr);
    return ret;
  }

  public void setEnergyFunction(string energy) {
    OpenMMSwigPINVOKE.CustomBondForce_setEnergyFunction(swigCPtr, energy);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addPerBondParameter(string name) {
    int ret = OpenMMSwigPINVOKE.CustomBondForce_addPerBondParameter(swigCPtr, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getPerBondParameterName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomBondForce_getPerBondParameterName(swigCPtr, index);
    return ret;
  }

  public void setPerBondParameterName(int index, string name) {
    OpenMMSwigPINVOKE.CustomBondForce_setPerBondParameterName(swigCPtr, index, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addGlobalParameter(string name, double defaultValue) {
    int ret = OpenMMSwigPINVOKE.CustomBondForce_addGlobalParameter(swigCPtr, name, defaultValue);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getGlobalParameterName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomBondForce_getGlobalParameterName(swigCPtr, index);
    return ret;
  }

  public void setGlobalParameterName(int index, string name) {
    OpenMMSwigPINVOKE.CustomBondForce_setGlobalParameterName(swigCPtr, index, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public double getGlobalParameterDefaultValue(int index) {
    double ret = OpenMMSwigPINVOKE.CustomBondForce_getGlobalParameterDefaultValue(swigCPtr, index);
    return ret;
  }

  public void setGlobalParameterDefaultValue(int index, double defaultValue) {
    OpenMMSwigPINVOKE.CustomBondForce_setGlobalParameterDefaultValue(swigCPtr, index, defaultValue);
  }

  public void addEnergyParameterDerivative(string name) {
    OpenMMSwigPINVOKE.CustomBondForce_addEnergyParameterDerivative(swigCPtr, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public string getEnergyParameterDerivativeName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomBondForce_getEnergyParameterDerivativeName(swigCPtr, index);
    return ret;
  }

  public int addBond(int particle1, int particle2, SWIGTYPE_p_std__vectorT_double_t parameters) {
    int ret = OpenMMSwigPINVOKE.CustomBondForce_addBond__SWIG_0(swigCPtr, particle1, particle2, SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int addBond(int particle1, int particle2) {
    int ret = OpenMMSwigPINVOKE.CustomBondForce_addBond__SWIG_1(swigCPtr, particle1, particle2);
    return ret;
  }

  public void getBondParameters(int index, SWIGTYPE_p_int particle1, SWIGTYPE_p_int particle2, SWIGTYPE_p_std__vectorT_double_t parameters) {
    OpenMMSwigPINVOKE.CustomBondForce_getBondParameters(swigCPtr, index, SWIGTYPE_p_int.getCPtr(particle1), SWIGTYPE_p_int.getCPtr(particle2), SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setBondParameters(int index, int particle1, int particle2, SWIGTYPE_p_std__vectorT_double_t parameters) {
    OpenMMSwigPINVOKE.CustomBondForce_setBondParameters__SWIG_0(swigCPtr, index, particle1, particle2, SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setBondParameters(int index, int particle1, int particle2) {
    OpenMMSwigPINVOKE.CustomBondForce_setBondParameters__SWIG_1(swigCPtr, index, particle1, particle2);
  }

  public void updateParametersInContext(Context context) {
    OpenMMSwigPINVOKE.CustomBondForce_updateParametersInContext(swigCPtr, Context.getCPtr(context));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setUsesPeriodicBoundaryConditions(bool periodic) {
    OpenMMSwigPINVOKE.CustomBondForce_setUsesPeriodicBoundaryConditions(swigCPtr, periodic);
  }

  public override bool usesPeriodicBoundaryConditions() {
    bool ret = OpenMMSwigPINVOKE.CustomBondForce_usesPeriodicBoundaryConditions(swigCPtr);
    return ret;
  }

}

}
